/* 
 * Autor:             Alexander Gossen
 * Modul:             Masterarbeit
 * Projekt:           Buzzerspiel
 * Bemerkung:         Ergänzung zum Projekt Buzzerspiel. Enthält alle Funktionen.
 * Letzte Änderung:   20.06.21
*/

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////// HIER NICHTS ÄNDERN ///////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

                                     ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void zeige_ergebnis(){               // Diese Funktion wird am Ende des Spiels aufgerufen um den Punktestand zu zeigen und das Spiel erneut zu starten //
                                     ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  Serial.print("Spieler 1: ");
  Serial.println(siege_spieler_1);
  Serial.print("Spieler 2: ");
  Serial.println(siege_spieler_2);
  Serial.println("Bitte den Reset-Knopf betätigen oder r eintippen!");
  Serial.println("                             ");
  Serial.println("                             ");
  Serial.println("                             ");
  Serial.println("                             ");
  Serial.println("                             ");
  Serial.println("                             ");
 
}
                                     ///////////////////////////////////////////////////////////////////////////
void reset_zufallsmodus(){           // Diese Funktion verhindert das am zum Spielende mehrere LED's leuchten //
                                     ///////////////////////////////////////////////////////////////////////////
if (laufzeit >= stopzeit){

  if (digitalRead(led_rot) == HIGH && digitalRead(led_gruen) == HIGH || digitalRead(led_rot) == HIGH && digitalRead(led_blau) == HIGH || digitalRead(led_gruen) == HIGH && digitalRead(led_blau) == HIGH || digitalRead(led_rot) == HIGH && digitalRead(led_gruen) == HIGH && digitalRead(led_blau) == HIGH){

    reset_zufall = random(0, 3);
    
    if (reset_zufall == 0){
      
      digitalWrite(led_blau, LOW);
      digitalWrite(led_gruen, LOW);
      digitalWrite(led_rot, HIGH);
      
    }
    
    else if (reset_zufall == 1){
      
      digitalWrite(led_blau, LOW);
      digitalWrite(led_rot, LOW);
      digitalWrite(led_gruen, HIGH);
      
    }
    
    else if (reset_zufall == 2){
      
      digitalWrite(led_gruen, LOW);
      digitalWrite(led_rot, LOW);
      digitalWrite(led_blau, HIGH);
      
    }
    
  }

  if (digitalRead(led_rot) == LOW && digitalRead(led_gruen) == LOW && digitalRead(led_blau) == LOW){
    
    reset_zufall_2 = random(0, 3);
    
    if (reset_zufall_2 == 0){
      
      digitalWrite(led_blau, LOW);
      digitalWrite(led_gruen, LOW);
      digitalWrite(led_rot, HIGH);
      
    }
    
    else if (reset_zufall_2 == 1){
      
      digitalWrite(led_blau, LOW);
      digitalWrite(led_rot, LOW);
      digitalWrite(led_gruen, HIGH);
      
    }
    
    else if (reset_zufall_2 == 2){
      
      digitalWrite(led_gruen, LOW);
      digitalWrite(led_rot, LOW);
      digitalWrite(led_blau, HIGH);
      
    }
    
  }
  
}
  
}
                                     ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int spielende(int stopzeit){         // Abhängig von der am Ende leuchtenden LED, wird nach Ablauf der Zeit das Spiel angehalten bis ein Taster betätigt wurde //
                                     // Das Argument bestimmt die Länge des Spiels //////////////////////////////////////////////////////////////////////////////
                                     ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  reset_zufallsmodus();

  if (laufzeit >= stopzeit){

  laufzeit = 0;
  
    while (true){

      if(digitalRead(led_rot) == 1){

        // Fallunterscheidung Spieler 1 (rote led)
        
        if (digitalRead(taster_1) == HIGH && taster_4_gedrueckt == false){
  
          taster_1_gedrueckt = true;
          tone(lautsprecher_1, 1000);
          delay(200);
          noTone(lautsprecher_1);
          siege_spieler_1++;
          taster_gedrueckt = true;
          break;
          
        }

        if (digitalRead(taster_2) == HIGH){
  
          //taster_2_gedrueckt = true;
          tone(lautsprecher_1, 1000);
          delay(200);
          noTone(lautsprecher_1);
          siege_spieler_1--;
          taster_gedrueckt = true;
          break;
          
        }

        if (digitalRead(taster_3) == HIGH){
  
          //taster_3_gedrueckt = true;
          tone(lautsprecher_1, 1000);
          delay(200);
          noTone(lautsprecher_1);
          siege_spieler_1--;
          taster_gedrueckt = true;
          break;
          
        }
        
        // Fallunterscheidung Spieler 2 (rote led)
        
        if (digitalRead(taster_4) == HIGH && taster_1_gedrueckt == false){
  
          taster_4_gedrueckt = true;
          tone(lautsprecher_2, 2000);
          delay(200);
          noTone(lautsprecher_2);
          siege_spieler_2++;
          taster_gedrueckt = true;
          break;
          
        }
//
        if (digitalRead(taster_5) == HIGH){
  
          //taster_5_gedrueckt = true;
          tone(lautsprecher_2, 2000);
          delay(200);
          noTone(lautsprecher_2);
          siege_spieler_2--;
          taster_gedrueckt = true;
          break;
          
        }

        if (digitalRead(taster_6) == HIGH){
  
          //taster_6_gedrueckt = true;
          tone(lautsprecher_2, 2000);
          delay(200);
          noTone(lautsprecher_2);
          siege_spieler_2--;
          taster_gedrueckt = true;
          break;
          
        }
        
//        else{
//
//        continue;
//
//        }
        
      }

      if(digitalRead(led_gruen) == 1){

        // Fallunterscheidung Spieler 1 (güne led)
        
        if (digitalRead(taster_1) == HIGH){
  
          //taster_1_gedrueckt = true;
          tone(lautsprecher_1, 1000);
          delay(200);
          noTone(lautsprecher_1);
          siege_spieler_1--;
          taster_gedrueckt = true;
          break;
          
        }

        if (digitalRead(taster_2) == HIGH && taster_5_gedrueckt == false){
  
          taster_2_gedrueckt = true;
          tone(lautsprecher_1, 1000);
          delay(200);
          noTone(lautsprecher_1);
          siege_spieler_1++;
          taster_gedrueckt = true;
          break;
          
        }

        if (digitalRead(taster_3) == HIGH){
  
          //taster_3_gedrueckt = true;
          tone(lautsprecher_1, 1000);
          delay(200);
          noTone(lautsprecher_1);
          siege_spieler_1--;
          taster_gedrueckt = true;
          break;
          
        }

        // Fallunterscheidung Spieler 2 (güne led)

        if (digitalRead(taster_4) == HIGH){
  
          //taster_4_gedrueckt = true;
          tone(lautsprecher_2, 2000);
          delay(200);
          noTone(lautsprecher_2);
          siege_spieler_2--;
          taster_gedrueckt = true;
          break;
          
        }

        if (digitalRead(taster_5) == HIGH && taster_2_gedrueckt == false){
  
          taster_5_gedrueckt = true;
          tone(lautsprecher_2, 2000);
          delay(200);
          noTone(lautsprecher_2);
          siege_spieler_2++;
          taster_gedrueckt = true;
          break;
          
        }

        if (digitalRead(taster_6) == HIGH){
  
          //taster_6_gedrueckt = true;
          tone(lautsprecher_2, 2000);
          delay(200);
          noTone(lautsprecher_2);
          siege_spieler_2--;
          taster_gedrueckt = true;
          break;
          
        }
        
//        else{
//
//        continue;
//
//        }
      }

      if(digitalRead(led_blau) == 1){

        // Fallunterscheidung Spieler 1 (blaue led)
        
        if (digitalRead(taster_1) == HIGH){
  
          //taster_1_gedrueckt = true;
          tone(lautsprecher_1, 1000);
          delay(200);
          noTone(lautsprecher_1);
          siege_spieler_1--;
          taster_gedrueckt = true;
          break;
          
        }

        if (digitalRead(taster_2) == HIGH){
  
          //taster_2_gedrueckt = true;
          tone(lautsprecher_1, 1000);
          delay(200);
          noTone(lautsprecher_1);
          siege_spieler_1--;
          taster_gedrueckt = true;
          break;
          
        }

        if (digitalRead(taster_3) == HIGH && taster_6_gedrueckt == false){
  
          taster_3_gedrueckt = true;
          tone(lautsprecher_1, 1000);
          delay(200);
          noTone(lautsprecher_1);
          siege_spieler_1++;
          taster_gedrueckt = true;
          break;
          
        }

        // Fallunterscheidung Spieler 2 (blaue led)

        if (digitalRead(taster_4) == HIGH){
  
          //taster_4_gedrueckt = true;
          tone(lautsprecher_2, 2000);
          delay(200);
          noTone(lautsprecher_2);
          siege_spieler_2--;
          taster_gedrueckt = true;
          break;
          
        }

        if (digitalRead(taster_5) == HIGH){
  
          //taster_5_gedrueckt = true;
          tone(lautsprecher_2, 2000);
          delay(200);
          noTone(lautsprecher_2);
          siege_spieler_2--;
          taster_gedrueckt = true;
          break;
          
        }

        if (digitalRead(taster_6) == HIGH && taster_3_gedrueckt == false){
  
          taster_6_gedrueckt = true;
          tone(lautsprecher_2, 2000);
          delay(200);
          noTone(lautsprecher_2);
          siege_spieler_2++;
          taster_gedrueckt = true;
          break;
          
        }
        
//        else{
//
//        continue;
//
//        }
      }

      if(taster_gedrueckt == true){

        break;
        
      }
    
    }

    while(true){
    i = 0;
    taster_1_gedrueckt = false;
    taster_2_gedrueckt = false;
    taster_3_gedrueckt = false;
    taster_4_gedrueckt = false;
    taster_5_gedrueckt = false;
    taster_6_gedrueckt = false;
    taster_gedrueckt = false;
    zeige_ergebnis();
    
      while(true){

        if (Serial.read() == 'r'){
          
          return 0;
          
        }
        
      }

    }
   
  }
  
}
                                     ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void vorzeitiges_ende(){             // Diese Funktion wird aufgerufen wenn ein Spieler einen Taster zu früh betätigt hat und zieht dem Spieler einen Punkt ab //
                                     ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                     
  if (digitalRead(taster_1) == HIGH || digitalRead(taster_2) == HIGH || digitalRead(taster_3) == HIGH && laufzeit <= stopzeit){ // Hier Änderungen vorgenommen
    
  reset_zufallsmodus();
  
  laufzeit = 0;
  i = 0;
  tone(lautsprecher_1, 3000);
  delay(200);
  noTone(lautsprecher_1);
  siege_spieler_1--;
  
    do{
      
      taster_1_gedrueckt = false;
      taster_4_gedrueckt = false;
      zeige_ergebnis();
      
      while(true){
        
        if (Serial.read() == 'r'){
          
          return 0;
          
        }
        
      }
      
    }while(true);
  
  }

  if (digitalRead(taster_4) == HIGH || digitalRead(taster_5) == HIGH || digitalRead(taster_6) == HIGH && laufzeit <= stopzeit){
    
  reset_zufallsmodus();
  
  laufzeit = 0;
  i = 0;
  tone(lautsprecher_2, 3000);
  delay(200);
  noTone(lautsprecher_2);
  siege_spieler_2--;
  
    do{
      
      taster_1_gedrueckt = false;
      taster_4_gedrueckt = false;
      zeige_ergebnis();
      
      while(true){
        
        if (Serial.read() == 'r'){
          
          return 0;
          
        }
        
      }
      
    }while(true);
  
  }

}
                                     /////////////////////////////////////////////////////////
void reset_laufzeit_aktiv(){         // Diese Funktion ermöglicht einen Neustart des Spiels //
                                     /////////////////////////////////////////////////////////
  if (Serial.read() == 'r'){

  i = 0;        
  return 0;
          
  }

}
