/* 
 * Autor:             Alexander Gossen
 * Modul:             Masterarbeit
 * Projekt:           Buzzerspiel
 * Bemerkung:         Hauptprogramm des Projektes Buzzerspiel
 * Letzte Änderung:   23.10.21
*/

#include "Buzzerspiel_Setup_Variablen.h"
#include "Buzzerspiel_Funktionen.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////// AB HIER KANN DER CODE VERÄNDERT WERDEN ///////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void loop() {

/////////////////////////////////////////////////////////////////////
///////// MIT DIESEN VARIABLEN KANN MAN DAS SPIEL VERÄNDERN /////////
/////////////////////////////////////////////////////////////////////
  
int *stopzeit_pointer = &stopzeit;// Verweis auf die Variable 'stopzeit' in der Headerdatei 'Buzzerspiel_Setup_Variablen'
*stopzeit_pointer = 100;          // Weist der Variable 'stopzeit' einen Wert von 100 zu

int *pause_1_pointer = &pause_1;  // Verweis auf die Variable 'pause_1' in der Headerdatei 'Buzzerspiel_Setup_Variablen'
*pause_1_pointer = 20;            // Weist der Variable 'pause_1' einen Wert von 20 zu

int *pause_2_pointer = &pause_2;  // Verweis auf die Variable 'pause_2' in der Headerdatei 'Buzzerspiel_Setup_Variablen'
*pause_2_pointer = random(10, 60);// Weist der Variable 'pause_2' einen zufälligen Wert zwischen 10 und 60 zu

reset_laufzeit_aktiv();           // Funktionsaufruf - Startet das Spiel von vorne wenn während der Laufzeit 'r' im seriellen Monitor getippt wird

laufzeit = i;
i++;                              // Erhöht die Variable 'laufzeit' um 1 bei jedem Durchlauf des Programms
spielende(stopzeit);              // Funktionsaufruf - Beendet das Spiel nach verstrichener Laufzeit (abhängig von der Variable 'stopzeit')
Serial.println(laufzeit);         // Gibt die Laufzeit im seriellen Monitor aus

vorzeitiges_ende();               // Funktionsaufruf - Beendet das das Spiel wenn ein Taster zu früh betätigt wurde und vergibt einen Minuspunkt



////////////////////////////////////////////////////////////////
///////// VERSION 1 - LED's leuchte in Reihenfolge aus /////////
////////////////////////////////////////////////////////////////

  digitalWrite(led_rot, HIGH);    // Rote LED einschalten
  delay(50);                      // Das Programm 50 Millisekunden anhalten
  spielende(stopzeit);            // Funktion stopzeit aufrufen
  digitalWrite(led_rot, LOW);     // Rote LED ausschalten
  
  digitalWrite(led_gruen, HIGH);  // Grüne LED einschalten
  delay(50);                      // Das Programm 50 Millisekunden anhalten
  spielende(stopzeit);            // Funktion stopzeit aufrufen
  digitalWrite(led_gruen, LOW);   // Grüne LED ausschalten
  
  digitalWrite(led_blau, HIGH);   // Blaue LED ausschalten
  delay(50);                      // Das Programm 50 Millisekunden anhalten
  spielende(stopzeit);            // Funktion stopzeit aufrufen
  digitalWrite(led_blau, LOW);    // Blaue LED ausschalten



///////////////////////////////////////////////////////////
///////// VERSION 2 - LED's leuchten zufällig auf /////////
///////////////////////////////////////////////////////////

  rot = random(0, 20);              // Für die Farbe Rot wird eine zufällige Zahl zwischen 0 und 20 erzeugt
  
  if (rot >= 10){                   // Prüfe, ob für die Farbe Rot eine Zahl größer als 10 oder gleich 10 erzeugt wurde... 
    
    digitalWrite(led_rot, HIGH);    // Rote LED einschalten
    
  }
  
  else if (rot < 10){               // Prüfe, ob für die Farbe Rot eine Zahl kleiner als 10 erzeugt wurde...
    
    digitalWrite(led_rot, LOW);     // Rote LED ausschalten
    
  }
  
  delay(15);                        // Das Programm für 15 Millisekunden anhalten
  
  spielende(stopzeit);              // Funktion spielende aufrufen
  
  gruen = random(0, 20);            // Für die Farbe Grün wird eine zufällige Zahl zwischen 0 und 20 erzeugt
  
  if (gruen >= 10){                 // Prüfe, ob für die Farbe Rot eine Zahl größer als 10 oder gleich 10 erzeugt wurde... 
    
    digitalWrite(led_gruen, HIGH);  // Grüne LED einschalten
    
  }
  
  else if(led_gruen < 10){          // Prüfe, ob für die Farbe Grün eine Zahl kleiner als 10 erzeugt wurde...
    
    digitalWrite(led_gruen, LOW);   // Grüne LED ausschalten
    
  }
  
  delay(15);                        // Das Programm für 15 Millisekunden anhalten
  
  spielende(stopzeit);              // Funktion spielende aufrufen
  
  blau = random(0, 20);             // Für die Farbe Blau wird eine zufällige Zahl zwischen 0 und 20 erzeugt        
  
  if (blau >= 10){                  // Prüfe, ob für die Farbe Blau eine Zahl größer als 10 oder gleich 10 erzeugt wurde... 
    
    digitalWrite(led_blau, HIGH);   // Blaue LED einschalten
    
  }
  
  else if (led_blau < 10){          // Prüfe, ob für die Farbe Blau eine Zahl kleiner als 10 erzeugt wurde...   
    
    digitalWrite(led_blau, LOW);
    
  }
  
  delay(15);                        // Das Programm für 15 Millisekunden anhalten
  
  spielende(stopzeit);              // Funktion spielende aufrufen
  
  reset_zufallsmodus();             // Funktionsaufruf - Verhindert das am Ende Spiels mehrere LED's leuchten

}
