/* 
 * Autor:             Alexander Gossen
 * Modul:             Masterarbeit
 * Projekt:           Buzzerspiel
 * Bemerkung:         Ergänzung zum Projekt Buzzerspiel. Enthält alle Variablen und den Setup-Code.
 * Letzte Änderung:   01.11.21
*/

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////// HIER NICHTS ÄNDERN ///////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int led_rot = 2;                         // Rote LED Pin 2 zuweisen
int led_gruen = 3;                       // Grüne LED Pin 3 zuweisen
int led_blau = 4;                        // Blaue LED Pin 4 zuweisen

int lautsprecher_1 = 5;                  // Lautsprecher 1 Pin 5 zuweisen
int lautsprecher_2 = 6;                  // Lautsprecher 2 Pin 6 zuweisen

int taster_1 = 9;                        // Taster 1 Pin 9 zuweisen
int taster_2 = 8;                        // Taster 2 Pin 8 zuweisen
int taster_3 = 7;                        // Taster 3 Pin 7 zuweisen
int taster_4 = 12;                       // Taster 4 Pin 12 zuweisen
int taster_5 = 11;                       // Taster 5 Pin 11 zuweisen
int taster_6 = 10;                       // Taster 6 Pin 10 zuweisen
bool taster_1_gedrueckt = false;         // Status von Taster 1 deaktiviert
bool taster_2_gedrueckt = false;         // Status von Taster 2 deaktiviert
bool taster_3_gedrueckt = false;         // Status von Taster 3 deaktiviert
bool taster_4_gedrueckt = false;         // Status von Taster 4 deaktiviert
bool taster_5_gedrueckt = false;         // Status von Taster 5 deaktiviert
bool taster_6_gedrueckt = false;         // Status von Taster 6 deaktiviert
bool taster_gedrueckt = false;           // Status eines beliebigen Tasters deaktiviert

int siege_spieler_1 = 0;                 // Punktezähler für Spieler 1
int siege_spieler_2 = 0;                 // Punktezähler für Spieler 2

unsigned int laufzeit = 0;               // Bestimmt die Länge des Spiels in Spielversion 1
int i = 0;                               // Laufvariable für die Länge des Spiels
int rot;                                 // Variable für den Zufallswert der roten LED in Spielversion 2
int gruen;                               // Variable für den Zufallswert der grünen LED in Spielversion 2
int blau;                                // Variable für den Zufallswert der blauen LED in Spielversion 2
int reset_zufall;                        // Speichert ein Zufallszahl für den Fall das am Ende des Spiels mehrere LED's leuchten
int reset_zufall_2;                      // Speichert ein Zufallszahl für den Fall das am Ende des Spiels mehrere LED's leuchten

int stopzeit = 30;                       // Anzahl der Durchläufe
int pause_1 = 30;                        // Dauer der Pause
int pause_2 = random(10, 100);           // Pause zufällig bestimmen

void setup() {

  Serial.begin(9600);                    // Seriellen Monitor starten
  
  pinMode(led_rot, OUTPUT);              // Die rote LED wird als Ausgang definiert
  pinMode(led_gruen, OUTPUT);            // Die grüne LED wird als Ausgang definiert
  pinMode(led_blau, OUTPUT);             // Die blaue LED wird als Ausgang definiert
  
  pinMode(lautsprecher_1, OUTPUT);       // Lautsprecher 1 wird als Ausgang definiert
  pinMode(lautsprecher_2, OUTPUT);       // Lautsprecher 2 wird als Ausgang definiert
  
  pinMode(taster_1, INPUT_PULLUP);       // Taster 1 wird als Eingang definiert und zusätzlich wird ein integrierter Pullup-Widerstand für den Taster aktiviert
  pinMode(taster_2, INPUT_PULLUP);       // Taster 2 wird als Eingang definiert und zusätzlich wird ein integrierter Pullup-Widerstand für den Taster aktiviert
  pinMode(taster_3, INPUT_PULLUP);       // Taster 3 wird als Eingang definiert und zusätzlich wird ein integrierter Pullup-Widerstand für den Taster aktiviert
  pinMode(taster_4, INPUT_PULLUP);       // Taster 4 wird als Eingang definiert und zusätzlich wird ein integrierter Pullup-Widerstand für den Taster aktiviert
  pinMode(taster_5, INPUT_PULLUP);       // Taster 5 wird als Eingang definiert und zusätzlich wird ein integrierter Pullup-Widerstand für den Taster aktiviert
  pinMode(taster_6, INPUT_PULLUP);       // Taster 6 wird als Eingang definiert und zusätzlich wird ein integrierter Pullup-Widerstand für den Taster aktiviert

}
